module Fulfillment
  module Models
    class Product < Model
      property :id, coerce: Integer
      property :venue
      property :event_title
      property :show_id, coerce: Integer
      property :supplier_manifest_emails, coerce: ->(v) { v.split("\n") rescue v }
      property :supplier_id, coerce: Integer
      property :fulfillment_details
      property :advisories
      property :created_at, coerce: ->(v) { DateTime.parse(v) rescue v }
      property :updated_at, coerce: ->(v) { DateTime.parse(v) rescue v }
      property :show_date_and_time
      property :automatically_generate_barcode
      property :inventory_id, coerce: Integer
      property :fulfillment_method
      property :fulfillment_data
      property :event_id, coerce: Integer
      property :allow_purchase_cancellations
      property :supplier_wrap_sheet_emails, coerce: ->(v) { v.split("\n") rescue v }
      property :barcode_format
    end
  end
end
