module Fulfillment
  module Resources
    module Orders
      extend self

      def find(params={})
        response = Request.new("orders/search", { search: params }).post
        Models::Collection.new(Models::Order, response.body)
      end

      def update(params={})
        id = params.delete(:id)
        response = Request.new("orders/#{id}", params).patch
        Models::Order.new(response.body)
      end

      def destroy(id)
        response = Request.new("orders/#{id}").delete
        response.status == 200
      end
    end
  end
end
